image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest

before_script:
  - cd ${TF_ROOT}


variables:
  TF_ROOT: ${CI_PROJECT_DIR}/terraform/
  TF_ADDRESS: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/Terraform/terraform.tfstate


stages:
  - prepare
  - validate
  - build
  - deploy


Initialise the infrastructure using terraform:
  stage: prepare
  script:
    - gitlab-terraform init

Validate the infrastructure using terraform:
  stage: validate
  script:
    - gitlab-terraform validate

Plan the infrastructure using terraform :
  stage: build
  script:
    - gitlab-terraform plan 
    - gitlab-terraform plan-json 
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json

Apply the infrastucture in Azure using terraform:
  stage: deploy
  environment:
    name: production
  script:
    - gitlab-terraform apply
    - kubectl apply -f ./kubernetes-manifests.yaml
    - kubectl get svc

  dependencies:
    - Plan the infrastructure using terraform 

